using UnityEngine;
using System.IO;
using System;
using HarmonyLib;
using System.Collections.Generic;

public class MoreTrashRedux : Mod
{
    static Dictionary<ObjectSpawnerAssetSettings, float> editedValues;
    static public JsonModInfo modInfo;
    static public bool DiffCheck;
    static public float GlobalDelay;
    static public float WorldDelay;
    static public bool GlobalCheck;
    static public bool WorldCheck;
    static public bool scheduleCheck;
    Harmony harmony;
    static public float multiplier
    {
        get
        {
            if (ExtraSettingsAPI_Loaded)
            {
                if (RAPI.GetLocalPlayer() == null || DiffCheck)
                    return GlobalCheck ? float.PositiveInfinity : GlobalDelay;
                return WorldCheck ? float.PositiveInfinity : WorldDelay;
            }
            return 0.5f;
        }
    }
    public void Start()
    {
        modInfo = modlistEntry.jsonmodinfo;
        editedValues = new Dictionary<ObjectSpawnerAssetSettings, float>();
        ModifyCurrentSettings();
        harmony = new Harmony("com.aidanamite.MoreTrashRedux");
        harmony.PatchAll();
        Log("Mod has been loaded!");
    }

    public void Update()
    {
        if (scheduleCheck)
        {
            getSettings();
            ModifyCurrentSettings();
            scheduleCheck = false;
        }
    }

    public void OnModUnload()
    {
        UnmodifyAll();
        Log("Mod has been unloaded!");
    }

    public static void Log(object message)
    {
        Debug.Log("[" + modInfo.name + "]: " + message.ToString());
    }

    public static void ErrorLog(object message)
    {
        Debug.LogError("[" + modInfo.name + "]: " + message.ToString());
    }

    public static void WarningLog(object message)
    {
        Debug.LogWarning("[" + modInfo.name + "]: " + message.ToString());
    }

    public static void ModifyCurrentSettings()
    {
        foreach (ObjectSpawner_RaftDirection objectSpawner in FindObjectsOfType<ObjectSpawner_RaftDirection>())
            ModifySettings(Traverse.Create(objectSpawner).Field("currentSettings").GetValue<ObjectSpawnerAssetSettings>());
    }

    public static void ModifySettings(ObjectSpawnerAssetSettings set)
    {
        if (set == null)
            return;
        if (editedValues == null)
            return;
        if (editedValues.TryAdd(set, set.spawnInterval))
            set.spawnInterval *= multiplier;
        else
            RemodifySettings(set);
    }

    public static void RemodifySettings(ObjectSpawnerAssetSettings set)
    {
        if (editedValues.ContainsKey(set))
            set.spawnInterval = editedValues[set] * multiplier;
    }

    public static void RemodifyAll()
    {
        if (editedValues == null || editedValues.Count <= 0)
            return;
        foreach (KeyValuePair<ObjectSpawnerAssetSettings,float> pair in editedValues)
            pair.Key.spawnInterval = pair.Value * multiplier;
    }

    public static void UnmodifyAll()
    {
        if (editedValues == null || editedValues.Count <= 0)
            return;
        foreach (KeyValuePair<ObjectSpawnerAssetSettings, float> pair in editedValues)
            pair.Key.spawnInterval = pair.Value;
        editedValues.Clear();
    }

    public void getSettings()
    {
        if (!ExtraSettingsAPI_Loaded)
            return;
        DiffCheck = ExtraSettingsAPI_GetCheckboxState("Use global settings");
        GlobalCheck = ExtraSettingsAPI_GetCheckboxState("Disable Trash Spawn");
        GlobalDelay = ExtraSettingsAPI_GetSliderRealValue("Spawn Delay");
        WorldCheck = ExtraSettingsAPI_GetCheckboxState("Disable Trash Spawn ");
        WorldDelay = ExtraSettingsAPI_GetSliderRealValue("Spawn Delay ");
    }
    public void ExtraSettingsAPI_SettingsClose()
    {
        getSettings();
        RemodifyAll();
    }
    public void ExtraSettingsAPI_Load()
    {
        getSettings();
        RemodifyAll();
    }
    public void ExtraSettingsAPI_Unload()
    {
        RemodifyAll();
    }
    public void ExtraSettingsAPI_ButtonPress(string name)
    {
        if (name == "Clear Items")
            if (Semih_Network.IsHost)
                foreach (ObjectSpawner_RaftDirection objectSpawner in FindObjectsOfType<ObjectSpawner_RaftDirection>())
                    while (objectSpawner.spawnedObjects.Count > 0)
                        PickupObjectManager.RemovePickupItemNetwork(objectSpawner.spawnedObjects[0]);
    }

    static Traverse ExtraSettingsAPI_Traverse;
    static bool ExtraSettingsAPI_Loaded = false;
    public bool ExtraSettingsAPI_GetCheckboxState(string SettingName)
    {
        if (ExtraSettingsAPI_Loaded)
            return ExtraSettingsAPI_Traverse.Method("getCheckboxState", new object[] { this, SettingName }).GetValue<bool>();
        return false;
    }
    public float ExtraSettingsAPI_GetSliderRealValue(string SettingName)
    {
        if (ExtraSettingsAPI_Loaded)
            return ExtraSettingsAPI_Traverse.Method("getSliderRealValue", new object[] { this, SettingName }).GetValue<float>();
        return 0;
    }
    public void ExtraSettingsAPI_SetCheckboxState(string SettingName, bool value)
    {
        if (ExtraSettingsAPI_Loaded)
            ExtraSettingsAPI_Traverse.Method("setCheckboxState", new object[] { this, SettingName, value }).GetValue();
    }
    public void ExtraSettingsAPI_SetSliderValue(string SettingName, float value)
    {
        if (ExtraSettingsAPI_Loaded)
            ExtraSettingsAPI_Traverse.Method("setSliderValue", new object[] { this, SettingName, value }).GetValue();
    }
}

[HarmonyPatch(typeof(SO_ObjectSpawner), "GetSettings")]
public class Patch_GetObjectSpawnerSettings
{
    static void Postfix()
    {
        MoreTrashRedux.scheduleCheck = true;
    }
}